/*
 * Storage data structure:
 * {
 *      config: {
 *          streamUrl: 'url',
 *          localTimeOffset: 1235 // millis (server time - local time)
 *      },
 *      parade: [
 *          name: 'string',
 *          tstart: 'yyyy-MM-ddTHH:mm',
 *          begin: 'HH:mm'
 *          id: 'yyyy-MM-ddTHH:mm' // == tstart
 *      ]
 * }
 */

(function(global, document, $, ajax, JSON, App, tvKeyValue, widgetApi) {

    var repo = new App.Repo('repo');
    var timeout = 60000; // 1 minute

    repo.loadData = function(successCallback, failCallback) {
		ajax({
            url: "http://www.kp.ru/smart-tv/lg/tvprogram.json",
            timeout: timeout,
            error: function() { failCallback() },
            success: function(res) {
                var parade = JSON.parse(res.responseText);

                parade.forEach(function(p, idx) {
                    p.id = p.tstart;
                });

                ajax({
                    url: "http://www.kp.ru/smart-tv/samsung/config.json",
                    timeout: timeout,
                    error: function() { failCallback() },
                    success: function(res) {
                        var config = JSON.parse(res.responseText);

                        config.streamUrl += "|COMPONENT=HLS";

                        ajax({
                            url: "http://www.kp.ru/timestamp?format=%FT%T",
                            //url: "http://www.kp.ru/timestamp",
                            timeout: timeout,
                            error: function() { failCallback() },
                            success: function(res) {
                                //App.debug(res.responseText);

                                var localNow = dateFromStruct(parseDateStruct(new Date().format("isoDateTime"))).getTime();
                                //App.debug(localNow);
                                var serverNow = dateFromStruct(parseDateStruct(res.responseText)).getTime();
                                //App.debug(serverNow);
                                //var serverNow = parseInt(res.responseText) * 1000;

                                config.localTimeOffset = serverNow + 4 * 60 * 60 * 1000 - localNow;
                                //App.debug(config.localTimeOffset);

                                successCallback({
                                    config: config,
                                    parade: parade
                                });
                            }
                        });
                    }
                });

			}
		});
    }

    App.registerRepo(repo);

})(this, document, jQuery, ajax, JSON, App, App.tvKeyValue, App.widgetApi);
