/**
 * Array.filter // http://www.tutorialspoint.com/javascript/array_filter.htm
 */
/*if (!Array.prototype.filter)
{
  Array.prototype.filter = function(fun / *, thisp* /)
  {
    var len = this.length;
    if (typeof fun != "function")
      throw new TypeError();

    var res = new Array();
    var thisp = arguments[1];
    for (var i = 0; i < len; i++)
    {
      if (i in this)
      {
        var val = this[i]; // in case fun mutates this
        if (fun.call(thisp, val, i, this))
          res.push(val);
      }
    }

    return res;
  };
}*/


/**
 * Fallback for localStorage // https://gist.github.com/1333934
 **/
;(function() {
    if (typeof localStorage == "undefined" && typeof FileSystem == "function") {
        var fileSyObj = new FileSystem();
        var fileName  = curWidget.id + "_localStorage.db";
        var LStorageClass = function() { }
        LStorageClass.prototype.isNotNative = true;
        var lStorage  = new LStorageClass();
        var changed   = false;

        // load or init localStorage file
        var fileObj = fileSyObj.openCommonFile(fileName, "r+");
        if (fileObj != null) {
            try {
                var data = JSON.parse(fileObj.readAll());
                for (var k in data) {
                    lStorage[k] = data[k];
                }
            } catch(e) { }
        } else {
            fileObj = fileSyObj.openCommonFile(fileName, "w")
            fileObj.writeAll("{}");
        }
        fileSyObj.closeCommonFile(fileObj);

        // Save storage
        LStorageClass.prototype.saveFile = function(delay) {
            if (changed && typeof JSON == 'object') {
                var $self = this;
                var save  = function() {
                    fileObj = fileSyObj.openCommonFile(fileName, "w")
                    fileObj.writeAll(JSON.stringify($self));
                    fileSyObj.closeCommonFile(fileObj);
                    changed = false;
                }
                if (typeof delay != 'undefined' && delay)
                    setTimeout(save, 100);
                else
                    save();
            }
        }

        LStorageClass.prototype.setItem = function(key, value) {
            changed = true;
            this[key] = value;
            this.saveFile(true);
            return this[key];
        }

        LStorageClass.prototype.getItem = function(key) {
            return this[key];
        }

        // MY ADDITION
        LStorageClass.prototype.clear = function() {
            for (var k in this) {
                if (Object.prototype.hasOwnProperty.call(this, k)) {
                    delete this[k];
                }
            }
            this.saveFile(true);
        }

        window.localStorage = lStorage;
    }
})();

function capitalize(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
}

/**
 * Utility to use ajax. Need this for two reasons:
 * - jQuery ajax doesn't work with SmartTV 2010/2011
 * - SmartTV's XHR supports cross-domain requests, yay!
 */
;(function(global, JSON) {

    var defaultOptions = {
            success:function(){},
            error:function(){},
            async:true,
            method:'GET',
            timeout: 0, // no timeout
        }
      , destroyXhr = function(xhr) {
            xhr.onreadystatechange = null;
            xhr.abort();
            xhr.destroy(); // SmartTV specific
        }
      , encodeData = function(data) {
            var res = "";
            for (k in data) {
                var v = data[k];
                if (v == null) {
                    res = (res ? res + "&" : "") +
                          encodeURIComponent(k) + "=null";
                } else if (typeof v == 'object') {
                    res = (res ? res + "&" : "") +
                          encodeURIComponent(k) + "=" + 
                          encodeURIComponent(JSON.stringify(v));
                } else {
                    res = (res ? res + "&" : "") +
                          encodeURIComponent(k) + "=" + 
                          encodeURIComponent(v);
                }
            }
            return res;
        }
      , runXhr = function(options) {
            options = $.extend({}, defaultOptions, options);

            var xhr = new XMLHttpRequest()
              , isPost = (options.method||'').toLowerCase() == 'post'
              , timeout = null
              , url
              , postData
              , queue = [];

            xhr.onreadystatechange = function() {
                if (xhr.readyState == 4) {
                    if (timeout) {
                        clearTimeout(timeout);
                        timeout = null;
                    }
                    if (xhr.status >= 200 && xhr.status < 300) {
                        if (options.success) {
                            options.success(xhr);
                        }
                    } else {
                        if (options.error) {
                            options.error(xhr);
                        }
                    }
                    destroyXhr(xhr);
                }
            };

            if (isPost) {
                url = options.url;
                postData = encodeData(options.data || {});
            } else {
                url = options.data ? options.url + "?" + encodeData(options.data) : options.url;
            }

            xhr.open(isPost ? "POST" : "GET", url, options.async);
            if (isPost) {
                xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            }

            if (options.timeout) {
                timeout = setTimeout(function() {
                    if (options.error) {
                        options.error(xhr);
                    }
                    destroyXhr(xhr);
                }, options.timeout);
            }

            xhr.send(postData);
        };

    global.ajax = function(options) {
        runXhr(options);
    };

})(this, JSON)

function traceObject(o) {
    alert(o);
    for (k in o) alert((k + ": " + o[k]).replace(/\n/g, "\\n").substring(0, 100));
}

/*(function(global, $, undefined) {

    / *function slice(ar) {
        return Array.prototype.slice.apply(ar, 
            Array.prototype.slice.call(arguments, 1));
    }

    function indexOf(ar/ *, obj* /) {
        return Array.prototype.indexOf.apply(ar, slice(arguments, 1));
    }

    $.fn.pageParentToThis = function(pageSize) {
        if (this.length != 1) {
            this.each(function() { $(this).pageParentToThis(pageSize) } );
            return this;
        }
        var target = this;

        var container = target.parent()
          , targetHeight = target.outerHeight(true) // include margins
          , items = container.children() // will have at least one (target)
          , targetIndex = indexOf(items, target[0])
          , pageHeight = container.height()
          , from = pageSize * Math.floor(targetIndex / pageSize)
          , to = from + pageSize;

        if (to >= items.length) {
            to = items.length;
        }

        items.hide();
        $(slice(items, from, to)).show();

        return this;
    }* /

    $.fn.pageParentToThis = function() {
        $.clearSelectorCache();

        if (this.length != 1) {
            this.each(function() { $(this).pageParentToThis() } );
            return this;
        }

        var target = this
          , container = target.parent()
          , items = container.children().not('.pager-overflow')
          , maxPageHeight = container.height()
          , curPageHeight = null
          , curPage = null
          , targetPage = null
          , firstPage = null
          , lastPage = null;

        if (!target.data('pager-item-height')) { // pager has not been initialized
            items.each(function() {
                $(this).data('pager-item-height', $(this).outerHeight(true));
            });
        } else if (target.is(':visible')) {
            // when initialized and already visible
            return this;
        }

        items.each(function() {
            var item = $(this)
              , itemHeight = item.data('pager-item-height');

            curPageHeight += itemHeight;

            if (curPage === null || curPageHeight > maxPageHeight) {
                curPageHeight = itemHeight;
                curPage = [];
                firstPage = firstPage || curPage;
                lastPage = curPage;
            }
            curPage.push(item.get(0));

            if (item.get(0) == target.get(0)) {
                targetPage = curPage;
            }
        });

        items.not(targetPage).hide();
        $(targetPage).show();

        if (targetPage == firstPage) {
            $('.pager-overflow-top', container).remove();
        } else if ($('.pager-overflow-top', container).length == 0) {
            $('<' + target.get(0).nodeName + '>')
                .addClass('pager-overflow pager-overflow-top')
                .css({
                    background: "url(images/scroll-overflow-shadow-top.png) repeat-x",
                    width: "100%",
                    height: "14px",
                    position: "absolute",
                    left: "0",
                    top: "0"
                })
                .prependTo(container);
        }

        if (targetPage == lastPage) {
            $('.pager-overflow-bottom', container).remove();
        } else if ($('.pager-overflow-bottom', container).length == 0) {
            $('<' + target.get(0).nodeName + '>')
                .addClass('pager-overflow pager-overflow-bottom')
                .css({
                    background: "url(images/scroll-overflow-shadow-bottom.png) repeat-x",
                    width: "100%",
                    height: "14px",
                    position: "absolute",
                    left: "0",
                    bottom: "0"
                })
                .appendTo(container);
        }

        return this;
    }

    / ** Scroll parent page-by-page so that $this element is visible * /
    / *$.fn.pageParentToThis = function() {

        if (this.length != 1) {
            this.each(function() { $(this).pageParentToThis() } );
            return this;
        }
        var target = this;
        if (!target.offsetParent().is(target.parent())) {
            throw new Error("Element must be a direct child of the offsetParent");
        }
        var container = target.offsetParent()
          , targetPos = target.position().top
          , targetHeight = target.outerHeight(true) // include margins
          , items = container.children() // will have at least one (target)
          , maxPageHeight = container.height()
          , curPageOffset = null
          , curPageHeight = 0;

        if (targetPos < 0 || targetPos + targetHeight > maxPageHeight) {
            items.each(function() {
                var item = $(this)
                  , itemPos = item.position().top + container.scrollTop()
                  , itemHeight = item.outerHeight(true) // including margins
                  , itemBottomOffset = itemPos + itemHeight;

                curPageHeight += itemHeight;

                if (curPageOffset === null || curPageHeight > maxPageHeight) {
                    curPageOffset = itemPos;
                    curPageHeight = itemHeight;
                }

                if (item.is(target)) {
                    return false; // break cycle
                }
            });

            container.scrollTop(curPageOffset);
        } // else: do nothing
        
        return this;
    }* /
})(this, jQuery);*/

(function(global, $, undefined) {
    $.fn.fillParent = function(allowOverflow) {
        if (this.length != 1) {
            this.each(function() { $(this).fillParent(allowOverflow) } );
            return this;
        }

        var w = this.width()
          , h = this.height()
          , pw = this.parent().width()
          , ph = this.parent().height()
          , wpad = (pw - w)/2
          , hpad = (ph - h)/2;

        if (!allowOverflow) {
            wpad = wpad < 0 ? 0 : wpad;
            hpad = hpad < 0 ? 0 : hpad;
        }

        this.css({
            paddingLeft: wpad + "px",
            paddingRight: wpad + "px",
            paddingTop: hpad + "px",
            paddingBottom: hpad + "px"
        });
    }
})(this, jQuery);

/*(function(global, $, undefined) {
    var pagerCls = "jq-pager"
      , pagerContentCls = "jq-pager-content"
      , pagerFillerCls = "jq-pager-filler"
      , pagerOverflowTopCls = "jq-pager-overflow-top"
      , pagerOverflowBottomCls = "jq-pager-overflow-bottom"
      , defaultOptions = {
            overlap: 0
        };

    function ensurePager(pager) {
        var filler = $('.'+pagerFillerCls, pager)
          , overflowTop = $('.'+pagerOverflowTopCls, pager)
          , overflowBottom = $('.'+pagerOverflowBottomCls, pager)
          , content = pager.children().not(filler).not(overflowTop).not(overflowBottom);

        if (content.length != 1) {
            throw new Error("Page panel must contain exactly one child.");
        }

        if (!pager.hasClass(pagerCls)) {
            pager
                .addClass(pagerCls)
                .css({
                    overflow: 'hidden'
                });
        }

        if (!content.hasClass(pagerContentCls)) {
            content.addClass(pagerContentCls);
        }

        if (filler.length == 0) {
            filler = $('<DIV>')
                .addClass(pagerFillerCls)
                .css({
                    clear: "both",
                    height: "100%"
                })
                .appendTo(pager);
        }

        if (overflowTop.length == 0) {
            overflowTop = $('<DIV>')
                .addClass(pagerOverflowTopCls)
                .prependTo(pager);
        }

        if (overflowBottom.length == 0) {
            overflowBottom = $('<DIV>')
                .addClass(pagerOverflowBottomCls)
                .appendTo(pager);
        }
    }

    function doPage(pager, where, options) {
        var overflowTop = $('.'+pagerOverflowTopCls, pager)
          , overflowBottom = $('.'+pagerOverflowBottomCls, pager)
          , filler = $('.'+pagerFillerCls, pager)
          , content = $('.'+pagerContentCls, pager)
          //, scroll = pager.scrollTop()
          , scroll = - parseInt(content.css('marginTop').replace('px', ''))
          , height = pager.height()
            // TODO: correct formula
          //, scrollHeight = content.outerHeight(true)
          , scrollHeight = filler.offset().top - content.offset().top - 1
          , pageHeight = height - options.overlap;

        if (pageHeight <= 0) {
            throw new Error("Too small page");
        }

        // TODO: correct formula
        var maxPage = Math.floor(scrollHeight / pageHeight)
          , curPage = Math.floor(scroll / pageHeight)
          , page;

        if (typeof where == 'number') {
            page = where;
            if (page < 0) {
                page = maxPage + page + 1; // -1 => maxN
            }
        } else if (where === "next") {
            page = curPage + 1;
        } else if (where === "prev") {
            page = curPage - 1;
        } else {
            var target = $(where);
            if (target.length != 1) {
                throw new Error("Pager taget must be exactly one element");
            }
            if (target.closest(pager).length == 0) { 
                throw new Error("Pager target must be an ancestor of the item")
            }
            page = Math.floor((target.offset().top - content.offset().top) / pageHeight);
        }

        page = (page > maxPage) ? maxPage : (page < 0) ? 0 : page;

        // Yeah, scroll here:
        //pager.scrollTop(page * pageHeight);
        content.css('marginTop', -1*page*pageHeight + "px");

        // Update overflow shadows

        if (page == 0) {
            overflowTop.hide();
        } else {
            overflowTop.show();
        }

        if (page == maxPage) {
            overflowBottom.hide();
        } else {
            overflowBottom.show();
        }

        overflowTop.css({ top: pager.scrollTop() });
        overflowBottom.css({ top: pager.scrollTop() + height - overflowBottom.height() });
    }

    $.fn.pageTo = function(where, options) {
        if (this.length != 1) {
            return this.each(function() { $(this).pageTo(where, options) })
        }

        if (typeof options == 'number') {
            options = $.extend({}, defaultOptions, { overlap: options })
        } else {
            options = $.extend({}, defaultOptions, options);
        }

        ensurePager(this);
        doPage(this, where, options);

        return this;
    }

})(this, jQuery);*/

$.clearSelectorCache = function() {
    $('<DIV>').appendTo(document.body).remove();
};

$.fn.styleProperty = function(name, val) {
    if (typeof val == 'undefined') {
        if (this.length == 0) {
            return null;
        }
        return (getComputedStyle ? getComputedStyle(this[0]) : this[0].currentStyle)
               .getPropertyValue(name)
    } else {
        this.css(name, val);
        return this;
    }
};

$.fn.styleHeight = function(h) {
    if (h == null) {
        if (this.length == 0) {
            return null;
        }
        return parseInt(this.styleProperty('height').replace('px', ''));
    } else {
        this.css({height: h+"px"});
        return this;
    }
};

$.fn.styleWidth = function(w) {
    if (w == null) {
        if (this.length == 0) {
            return null;
        }
        return parseInt(this.styleProperty('width').replace('px', ''));
    } else {
        this.css({width: w+"px"});
        return this;
    }
};

;(function(global, $) {
    function PagingList(){}

    PagingList.prototype._init = function(ui, pageSize, adapter, items, cur) {
        var self = this;
        // TODO: add checks
        self.ui = $(ui)
            .addClass('jq-pgl')
            .css({ overflow: 'hidden', position: 'relative' });

        self.overflowTop = $('<DIV>').addClass('jq-scroll-overflow-top').appendTo(self.ui);
        self.overflowBottom = $('<DIV>').addClass('jq-scroll-overflow-bottom').appendTo(self.ui);
        self.scrollLine = $('<DIV>').addClass('jq-scroll-line').appendTo(self.ui);
        self.scrollSlider = $('<DIV>').addClass('jq-scroll-slider').appendTo(self.scrollLine);

        self.pageSize = pageSize; // integer > 0
        self.createView = adapter.createView || function() {return $('<DIV>')};
        self.notifyPageChanged = adapter.onPageChanged || function(){};
        self.notifySelectionChanged = adapter.onSelectionChanged || function(){};
        self.notifyPageDrawn = adapter.onPageDrawn || function(){};

        self.curIndex = -1;
        self.items = [];
        self.views = [];

        self.setItems(items, cur);
    }

    PagingList.prototype._destroy = function() {
        this.overflowTop.remove();
        this.overflowBottom.remove();
        this.scrollSlider.remove();
        this.scrollLine.remove();
        this.views.forEach(function(v) { v.remove() });
        this.ui.removeData('paging-list');
    }

    PagingList.prototype.setItems = function(items, cur) {
        var self = this;
        cur = typeof cur == 'undefined' ? (self.getSelectedItem() || {}).id : cur;

        self.items = (items || []).slice();
        self.itemsMap = {};
        self.items.forEach(function(item, index) {
            if (typeof item.id != 'string') {
                throw new Error("Items must have an id string");
            }

            self.itemsMap[item.id] = index;
        });

        self.views.forEach(function(v) { v.remove() });

        self.curIndex = -1;
        self.page = -1;
        self.views = [];

        self.setSelection(cur);
    }

    PagingList.prototype.redrawItems = function() {
        this.setSelection((this.getSelectedItem() || {}).id, true);
    }

    PagingList.prototype._getIndexForData = function(data) {
        var self = this
          , res;
        if (data == null) {
            res = -1;
        } else if (typeof data == 'number') {
            if (data < 0) data = 0;
            if (data >= self.items.length) data = self.items.length - 1;
            res = data;
        } else if (typeof data == 'string') {
            res = self.itemsMap[data];
        } else if (typeof data == 'object') {
            res = self.itemsMap[data.id];
        }
        if (res == null) {
            res = -1;
        }
        return res;
    }

    PagingList.prototype._updateOverflows = function() {
        var self = this;

        if (self.page > 0) {
            self.overflowTop.show();
        } else {
            self.overflowTop.hide();
        }
        if (self.page < self.getPagesCount() - 1) {
            self.overflowBottom.show();
        } else {
            self.overflowBottom.hide();
        }
    }
    PagingList.prototype._updateScrollbar = function() {
        // update scrollbar
        var pages = this.getPagesCount()
          , curPage = this.getCurrentPage()
          , sbHeight = this.scrollLine.styleHeight()
          , sbSliderHeight = Math.floor(sbHeight / pages)
          , offset = Math.floor((sbHeight - sbSliderHeight) * curPage / (pages-1));

        if (pages == 1) {
            this.scrollLine.hide();
        } else {
            this.scrollLine.show();
            //alert(pages + " " + curPage + " " + sbHeight + " " + sbSliderHeight + " " + offset);
            this.scrollSlider.height(sbSliderHeight);
            this.scrollSlider.css({marginTop: offset + "px"});
        }
    }

    PagingList.prototype.setSelection = function(cur, forceRedraw) {
        var self = this
          , bakIndex = self.curIndex
          , bakPage = self.page
          , redrawn = false;

        self.curIndex = self._getIndexForData(cur);

        self.page = self.curIndex < 0 ? 0 : Math.floor(self.curIndex/self.pageSize);
        if (self.page != bakPage || forceRedraw) {
            redrawn = true;
            self.views.forEach(function(v) { v.remove() });
            self.views = [];
            for (var i = self.page * self.pageSize;
                     i < Math.min((self.page+1) * self.pageSize, self.items.length);
                     i++) {

                 self.views[i] = $(self.createView(self.items[i]));
                 self.views[i].appendTo(self.ui);
                
            }
        }
        $(self.views[bakIndex]).removeClass('item-current');
        $(self.views[self.curIndex]).addClass('item-current');

        if (self.page != bakPage) {
            self.notifyPageChanged(self.page);
            self.ui.trigger('pageChange');

            self._updateOverflows();
            self._updateScrollbar();

            // doesn't work at the first time on 2011
            setTimeout(function() {
                self._updateOverflows();
                self._updateScrollbar();
            }, 0);
        }
        if (self.curIndex != bakIndex) {
            self.notifySelectionChanged(self.curIndex, self.items[self.curIndex]);
            self.ui.trigger('selectionChange');
        }
        if (redrawn) {
            self.notifyPageDrawn();
            self.ui.trigger('redraw');
        }
        return self;
    }

    PagingList.prototype.getSelectedId = function() {
        return (this.items[this.curIndex] || {}).id;
    }

    PagingList.prototype.getSelectedItem = function() {
        return this.items[this.curIndex] || null;
    }

    PagingList.prototype.getSelectedIndex = function() {
        return this.curIndex;
    }

    PagingList.prototype.getSelectedView = function() {
        return this.views[this.curIndex] || null;
    }

    PagingList.prototype.getCurrentPage = function() {
        return this.page;
    }

    PagingList.prototype.getItemsCount = function() {
        return this.items.length;
    }

    PagingList.prototype.getPagesCount = function() {
        return Math.max(1, Math.ceil(this.items.length / this.pageSize));
    }

    PagingList.prototype.removeItem = function(index) {
        var idx = this._getIndexForData(index);
        if (idx >= 0) {
            var newSel = this.curIndex == idx ? idx : this.getSelectedId()
              , newItems = this.items.slice();

            newItems.splice(idx, 1);
            this.setItems(newItems, newSel);
        }
    }

    PagingList.prototype.insertItem = function(item, index, /*optional*/ select) {
        var newSel = select ? item.id : this._getSelectedId()
          , newItems = this.items.slice();

        newItems.splice(index < 0 ? items.length : index, 0, item);

        this.setItems(newItems, newSel);
    }

    $.fn.pagingList = function(pageSize, adapter, /*optional*/ items, cur) {
        if (arguments.length > 0) {
            if (this.data('paging-list')) {
                this.data('paging-list').destroy();
            }
            this.data('paging-list', new PagingList());
            this.data('paging-list')._init(this, pageSize, adapter, items, cur);
        }
        return this.data('paging-list');
    }

})(this, jQuery);


;(function(global, $) {
    function TextScroller(){}

    var defaultOptions = {
        initialScroll: 0,
        delta: 220,
    }

    TextScroller.prototype._init = function(ui, options) {
        options = $.extend({}, defaultOptions, options);

        var self = this;
        self.ui = $(ui)
            .addClass('jq-tps')
            .css({overflowX: 'hidden', overflowY: 'scroll', position: 'relative'});

        self.content = self.ui.children();

        if (self.content.length != 1) {
            throw new Error("TextPager must have the only one child to page");
        }

        var clearer = $('.jq-tps-clearer', self.content);

        if (clearer.length == 0) {
            $('<DIV>').addClass('jq-tps-clearer').css('clear', 'both').appendTo(self.content);
        }

        self.delta = options.delta;
        self.scroll = 0;

        self.filler = $('<DIV>').css({
            height: self.delta + "px",
            clear: "both",
        }).appendTo(self.ui);

        self.pageHeight = self.ui.styleHeight();
        self.contentHeight = self.content.styleHeight() + parseInt(self.content.styleProperty('padding-top').replace('px', '')) + parseInt(self.content.styleProperty('margin-top').replace('px', '')) + 10 /* HACK: additional 10px */;

        //alert(self.pageHeight + " " + self.contentHeight);

        self.overflowTop = $('<DIV>')
            .addClass('jq-scroll-overflow-top')
            .width(self.ui.outerWidth())
            .appendTo(self.ui);
        self.overflowBottom = $('<DIV>')
            .addClass('jq-scroll-overflow-bottom')
            .width(self.ui.outerWidth())
            .appendTo(self.ui);
        self.scrollLine = $('<DIV>')
            .addClass('jq-scroll-line')
            .appendTo(self.ui);
        self.scrollSlider = $('<DIV>')
            .addClass('jq-scroll-slider')
            .appendTo(self.scrollLine);

        if (self.pageHeight >= self.contentHeight) {
            self.scrollLine.hide();
        }
        
        self.setCurrentScroll(options.initialScroll || 0);
    }

    TextScroller.prototype._destroy = function() {
        if (this._scrollTimer) {
            clearTimeout(this._scrollTimer);
        }
        this.ui.removeData('text-scroller');
        this.overflowTop.remove();
        this.overflowBottom.remove();
        this.scrollSlider.remove();
        this.scrollLine.remove();
        this.filler.remove();
    }

    TextScroller.prototype.getMaxScroll = function() {
        var tmp = this.contentHeight - this.pageHeight
          , add = Math.floor(tmp%this.delta) > 0;
        //alert("h: " + this.contentHeight + " t:" + tmp + " d:" + this.delta + " t%d:" + (tmp%this.delta));
        if (tmp <= 0) {
            return 0;
        } else if (!add) {
            return tmp;
        } else {
            return tmp + this.delta - Math.floor(tmp % this.delta);
        }
    }

    TextScroller.prototype.setCurrentScroll = function(scroll) {
        var self = this
          , max = self.getMaxScroll()
          , positions
          , bakScroll = self.scroll
          , actualDelta;

        if (scroll == "up") {
            scroll = self.scroll - self.delta;
        } else if (scroll == "down") {
            scroll = self.scroll + self.delta;
        }
        if (scroll > max) {
            scroll = max;
        }
        if (scroll < 0) {
            scroll = 0;
        }

        if (this._scrollTimer) {
            clearTimeout(this._scrollTimer);
        }

        self.scroll = scroll;

        // initial position
        self.content.css({marginTop: -bakScroll + "px"});

        actualDelta = scroll - bakScroll;
        positions = [
            bakScroll + Math.floor(actualDelta/5), 
            bakScroll + Math.floor(4*actualDelta/5),
            scroll
        ];
        self._scrollTimer = setInterval(function() {
            if (positions.length) {
                self.content.css({marginTop: -positions[0] + "px"});
                positions = positions.slice(1);
            } else {
                clearInterval(self._scrollTimer);
            }
        }, 30);
        //self.content.css({marginTop: -self.scroll + "px"});

        //alert(scroll + " of " + max + " (" + self.contentHeight + " " + self.pageHeight + ")");

        if (self.scroll > 0) {
            self.overflowTop.show();
        } else {
            self.overflowTop.hide();
        }
        if (self.scroll < max) {
            self.overflowBottom.show();
        } else {
            self.overflowBottom.hide();
        }

        // update scrollbar
        var sbHeight = this.scrollLine.styleHeight()
          , sbSliderHeight = Math.floor(sbHeight * Math.min(self.pageHeight / self.contentHeight, 1))
          , offset = Math.floor((sbHeight - sbSliderHeight) * scroll / max);

        //alert(sbHeight + " " + sbSliderHeight + " " + offset);
        self.scrollSlider.height(sbSliderHeight);
        self.scrollSlider.css({marginTop: offset + "px"});
    }

    $.fn.textScroller = function(options) {
        if (arguments.length > 0) {
            if (this.data('text-scroller')) {
                this.data('text-scroller')._destroy();
            }
            this.data('text-scroller', new TextScroller());
            this.data('text-scroller')._init(this, options);
        }
        return this.data('text-scroller');
    }

})(this, jQuery);

;(function(global, undefined) {
    /**
     * BASED ON
     * Date.parse with progressive enhancement for ISO 8601 <https://github.com/csnover/js-iso8601>
     * © 2011 Colin Snover <http://zetafleet.com>
     * Released under MIT license.
     */
    var numericKeys = [ 1, 4, 5, 6, 7, 10, 11 ];
    global.parseDateStruct = function(date) {
        var struct, minutesOffset = 0;

        // ES5 §15.9.4.2 states that the string should attempt to be parsed as a Date Time String Format string
        // before falling back to any implementation-specific date parsing, so that’s what we do, even if native
        // implementations could be faster
        //              1 YYYY                2 MM       3 DD           4 HH    5 mm       6 ss        7 msec        8 Z 9 ±    10 tzHH    11 tzmm
        if ((struct = /^(\d{4}|[+\-]\d{6})(?:-(\d{2})(?:-(\d{2}))?)?(?:T(\d{2}):(\d{2})(?::(\d{2})(?:\.(\d{3}))?)?(?:(Z)|([+\-])(\d{2})(?::(\d{2}))?)?)?$/.exec(date))) {
            // avoid NaN timestamps caused by “undefined” values being passed to Date.UTC
            for (var i = 0, k; (k = numericKeys[i]); ++i) {
                struct[k] = +struct[k] || 0;
            }

            // allow undefined days and months
            struct[2] = (+struct[2] || 1) - 1;
            struct[3] = +struct[3] || 1;

            if (struct[8] !== 'Z' && struct[9] !== undefined) {
                minutesOffset = struct[10] * 60 + struct[11];

                if (struct[9] === '+') {
                    minutesOffset = 0 - minutesOffset;
                }
            }

            return {
                year: struct[1],
                month: struct[2],
                day: struct[3],
                hours: struct[4],
                minutes: struct[5],
                seconds: struct[6],
                milliseconds: struct[7],
                minutesOffset: minutesOffset,
            };
        }
        else {
            return null;
        }
    }

    global.dateFromStruct = function(d, countOffset) {
        var minutes = d.minutes;
        if (countOffset) {
            minutes += d.minutesOffset;
        }

        return new Date(d.year, d.month, d.day, d.hours, minutes, d.seconds, d.milliseconds);
    }

    global.formatDateStruct = function(d, format, countOffset) {
        return global.dateFromStruct(d, countOffset).format(format);
    }
})(this)
