(function(global, document, $, ajax, JSON, App, tvKeyValue, widgetApi, pluginApi) {

    var defaultUrl = "http://live.kp.cdnvideo.ru/kp-live/test/playlist.m3u8|COMPONENT=HLS";

    var S = function() {};

    S.prototype = new VideoScene();

    S.prototype._updateParade = function() {
        var self = this
          , data = self._repo.getData()

        if (data) {
            var curProgramStart = null
              , nextProgramStart = null
              , idxFrom = -1
              , nowDate = new Date()
              , now
              , breakException = {}
              , items = [];

            //App.debug(data.config.localTimeOffset);
            //App.debug(nowDate);
            nowDate = new Date(nowDate.getTime() + data.config.localTimeOffset);
            //App.debug(nowDate);

            now = nowDate.format("isoDateTime");
            //App.debug(now);

            try {
                data.parade.forEach(function(item, idx) {
                    if (item.tstart < now) {
                        curProgramStart = item.tstart;
                        idxFrom = idx;
                    } else if (item.tstart >= now) {
                        nextProgramStart = item.tstart;
                        throw breakException;
                    }
                });
            } catch (err) {
                if (err !== breakException) {
                    throw err;
                }
            }

            if (idxFrom >= 0) {
                items = data.parade.slice(idxFrom);
            } else {
                items = data.parade;
            }
            self.pgl.setItems(items);

            if (self._updateParadeTimer) {
                clearTimeout(self._updateParadeTimer);
            }

            if (nextProgramStart) {
                self._updateParadeTimer = setTimeout(
                        function() { self._updateParade() }, 
                        (dateFromStruct(parseDateStruct(nextProgramStart)).getTime() - 
                         dateFromStruct(parseDateStruct(now)).getTime())
                );
            }
        }

        self.setDataState(self._repo.isLoading(), self._repo.hasData());
    }

    /** 
     * dom - DIV element
     **/
    S.prototype.init = function(dom) {
        var self = this;

        VideoScene.prototype.init.apply(this, arguments);

        self.setControlTipsUi([
            { icon: "d", title: "О нас" },
            { icon: "enter", title: "Полный экран" },
            { icon: "back", title: "Выход" }
        ]);

        self.pgl = self.uiParadeList.pagingList(11, {
            createView: function(item) {
                var li = App.renderTemplate(self.tmplItem, item);
                return li;
            },
            onPageChanged: function() {
                this.views.forEach(function(v) {
                    v.fields().uiText.fillParent();
                })
            },
            onSelectionChanged: function(idx, item) {
                if (item.description) {
                    self.uiTipRead.show();
                } else {
                    self.uiTipRead.hide();
                }
            }
        });

        self._repo = App.repos.repo;
        self._repo.registerListener(self);

        self._updateParade();
    };


    S.prototype._getUrl = function(data) {
        var data = data || this._repo.getData();
        if (data && data.config && data.config.streamUrl) {
            return data.config.streamUrl;
        } else {
            return defaultUrl;
        }
    }

	S.prototype.onPlayerRenderingComplete = function() {
		this.stopVideo();
	}
	
    S.prototype.finish = function() { VideoScene.prototype.finish.apply(this); this._repo.unregisterListener(this) };


    S.prototype.onStart = function(isResumed, finishedSceneName, finishedSceneResult) {
        this.showLoading();

        this.setVideoRegion(403, 123, 544, 306);

		alert('start');

        this.startVideo(this._getUrl());
    };
    S.prototype.onPause = function() {
		alert('pause');
        VideoScene.prototype.onPause.apply(this); 
        this.stopVideo();
    };

    S.prototype.onLoadingStarted = function(repo) { this.setDataState(repo.isLoading(), repo.hasData()) };
    S.prototype.onLoadingSucceeded = function(repo, data) {
        this._updateParade();
        alert(loaded);
        var url = this._getUrl(data);
        if (this.isActive() && this.currentUrl != url) {
            this.startVideo(url);
        }
    };
    S.prototype.onLoadingFailed = function(repo) { this.setDataState(repo.isLoading(), repo.hasData()) };

    S.prototype.onKeyDown = function(keyCode) {
        switch(keyCode) {
            case tvKeyValue.KEY_ENTER:
                App.startScene('FullScreenVideo', this.currentUrl);
                return true;
            case tvKeyValue.KEY_BLUE:
                App.startScene('About');
                return true;
            default:
                return VideoScene.prototype.onKeyDown.apply(this, arguments);
        }
    }

    App.registerSceneClass(S, 'Main');

})(this, document, jQuery, ajax, JSON, App, App.tvKeyValue, App.widgetApi, App.pluginApi);
